#!/usr/bin/php
<?php

$timezone  = parse_ini_file('../../../../../var/netdeep/main/settings',true);
$proxy  = parse_ini_file('../../../../../var/netdeep/proxy/settings',true);
$time = explode('posix/', $timezone['TIMEZONE']);
date_default_timezone_set($time[1]);

# Program: mysar, File: bin/mysar-maintenance.php
# Copyright 2004-2006, Stoilis Giannis <giannis@stoilis.gr>
#
# This file is part of mysar.
#
# mysar is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# mysar is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Foobar; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# record start time, to stop execution if time is exceeded...
$startTime=time();
$yesterdayTimestamp=$startTime-86400;

// calculate the base path of the program
$basePath=realpath(dirname(__FILE__).'/../');

$DEBUG_MODE='cmd';
$DEBUG_LEVEL='30';

// Common tasks for both web and cmd
require($basePath.'/inc/connection.inc.php');
require($basePath.'/inc/include.php');
$today = date('Y-m-d');

$tmpPath = getConfigValue('tmpPath');

error_reporting(E_ALL);

print_r('Start timestamp is '.$startTime);
//print_r('Configuration:'.print_r($iniConfig,TRUE));

$maxRunTime=55;

$db = new DBConn();
$conn = $db->DBConn();

//$cleanUntil = date('Y-m-d',time(0,0,0,substr($today,5,2),substr($today,8,2)-getConfigValue('keepHistoryDays'),substr($today,0,4)));
$cleanUntil = date('Y-m-d', strtotime('-'.getConfigValue('keepHistoryDays').' days', strtotime($today)));
print_r('Cleaning up until '.$cleanUntil);
	
// array containing tables to be cleaned
$cleanTable=array('sites', 'traffic', 'trafficSummaries', 'users');
reset($cleanTable);

//while(list($key,$tableName)=each($cleanTable)) {
foreach($cleanTable as $key => $tableName) {	
	print_r('Cleaning-up '.$tableName.'...');
	$query = 'DELETE FROM '.$tableName." WHERE date < '".$cleanUntil."'";
	$stm = $conn->query($query);
	print_r('Affected rows '.$stm->rowCount().'...');
	sleep(0.5);
}

$query='SHOW TABLES';
$tables = $conn->query($query);

reset($tables);

//while(list($key,$tableName)=each($tables)) {
foreach($cleanTable as $key => $tableName) {		
	$timestampNow=time();
	print_r('Now timestamp is: '.$timestampNow.'. Script start was at: '.$startTime);
	print_r('Checking if run time exceeded '.$maxRunTime.' seconds...');
	if(($timestampNow-$startTime ) > $maxRunTime) {
		print_r('YES',40);
		print_r('Exceeded run time');
		my_exit(0);
	}
	print_r('NO',40);

	$query2 ="OPTIMIZE TABLE $tableName[0]";
	print_r('Optimizing '.$tableName[0].'...');
	$conn->query($query2 );
	print_r('Optimization finished.');
}

	
print_r('Updating last clean-up date to today date...');
$query3 = "UPDATE config SET value='".date('Y-m-d')."' WHERE name='lastCleanUp'";
db_update($query3 );
echo "\n";



?>
