#!/usr/bin/php
<?php

$timezone  = parse_ini_file('../../../../../var/netdeep/main/settings',true);
$time = explode('posix/', $timezone['TIMEZONE']);
date_default_timezone_set($time[1]);

# Program: mysar, File: bin/mysar-maintenance.php
# Copyright 2004-2006, Stoilis Giannis <giannis@stoilis.gr>
#
# This file is part of mysar.
#
# mysar is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published by
# the Free Software Foundation.
#
# mysar is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Foobar; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


# record start time, to stop execution if time is exceeded...
$startTime=time();
$yesterdayTimestamp=$startTime-86400;

// calculate the base path of the program
$basePath=realpath(dirname(__FILE__).'/../');

$DEBUG_MODE='cmd';
$DEBUG_LEVEL='30';

// Common tasks for both web and cmd
require($basePath.'/inc/connection.inc.php');
require($basePath.'/inc/include.php');

print_r('Checking whether resolving is enabled...');
$resolveClients = getConfigValue('resolveClients');
if($resolveClients != 'enabled') {
	print_r('Resolving is NOT enabled. Exiting...');
	exit(0);
}
print_r('Resolving is enabled.');

error_reporting(E_ALL);

print_r('Start timestamp is '.$startTime);

$db = new DBConn();
$conn = $db->DBConn();

$maxRunTime=55;

$query='SELECT ';
$query.='id';
$query.=',';
$query.='INET_NTOA(ip) AS ip';
$query.=' FROM ';
$query.=' hostnames ';
$query.=' WHERE ';
$query.="isResolved='0'";
$query.=' ORDER BY id ASC';
$result  = $conn->query($query);
#print_r($result->fetchAll());
foreach($result->fetchAll() as $row) {
	$timestampNow = time();
	print_r('Now timestamp is: '.$timestampNow.'. Script start was at: '.$startTime);
	print_r('Checking if run time exceeded '.$maxRunTime.' seconds...');
	if(($timestampNow-$startTime ) > $maxRunTime) {
		print_r('YES');
		print_r('Exceeded run time');
		my_exit(0);
	}
	print_r('NO');
	$hostname = gethostbyaddr($row['ip']);
	$query2='UPDATE ';
	$query2.='hostnames';
	$query2.=' SET ';
	$query2.="hostname='".$hostname."'";
	$query2.=',';
	$query2.="isResolved='1'";
	$query2.=' WHERE ';
	$query2.="id='".$row['id']."'";
	db_update($query2,1);
	print_r('.');
	
}
print_r('Updating last resolver timestamp...');
$query3="UPDATE config SET value='".time()."' WHERE name='lastResolve'";
db_update($query3);
echo "\n";

?>
