#!/usr/bin/php
<?php

$timezone  = parse_ini_file('../../../../../var/netdeep/main/settings', true);
$time = explode('posix/', $timezone['TIMEZONE']);
date_default_timezone_set($time[1]);

$startTime=mktime();
$yesterdayTimestamp = $startTime-86400;

$basePath=realpath(dirname(__FILE__).'/../');

$DEBUG_MODE='cmd';
$DEBUG_LEVEL='30';

require($basePath.'/inc/connection.inc.php');
require($basePath.'/inc/include.php');

error_reporting(E_ALL);


$mysarImporter = getConfigValue('mysarImporter');

if($mysarImporter != 'enabled') {
	exit(0);
}

ini_set("memory_limit", "5G");
$maxRunTime=9999999999999;

$inCacheCodes[]='TCP_HIT';
$inCacheCodes[]='TCP_REFRESH_HIT';
$inCacheCodes[]='TCP_DENIED';
$inCacheCodes[]='TCP_REF_FAIL_HIT';
$inCacheCodes[]='TCP_NEGATIVE_HIT';
$inCacheCodes[]='TCP_MEM_HIT';
$inCacheCodes[]='TCP_OFFLINE_HIT';

$lastTimestamp = getConfigValue('lastTimestamp');
$squidLogFile = getConfigValue('squidLogPath');

if(!file_exists($squidLogFile)) {
	print_r('ERROR: squid log file('.$squidLogFile.') does not exist!');
	print_r('Exiting...');
	die(1);
}

$handle = fopen($squidLogFile,"r");
if(!$handle) {
	print_r('ERROR: Falha ao abrir arquivo de log '.$iniConfig['squidLog']);
	my_exit(1);
}

$lastLogOffset = getConfigValue('lastLogOffset');

$buffer = fgets($handle, 4096);
$record = preg_split("/\s+/",$buffer);

$firstLogTimestamp = getConfigValue('firstLogTimestamp');

if($record['0'] == $firstLogTimestamp && $firstLogTimestamp != '') {
	print_r('Este é um arquivo de log conhecido. Pulando para compensar '.$lastLogOffset.'...');
	fseek($handle, $lastLogOffset);
} else {
	print_r('Este é um novo arquivo de log.');
	fseek($handle, 0);
	updateConfig('lastLogOffset',0);
	updateConfig('firstLogTimestamp',$record['0']);
}


while (($timezone_diff = (gmmktime() - mktime()))%10);

$lastImportedRecordsNumber=0;
$file = file($squidLogFile);
echo "<pre>";
foreach($file as $linha):
    $timestampNow=mktime();
    
    if(($timestampNow - $startTime ) > $maxRunTime) {
		my_exit(0);
    }
    

    $buffer=fgets($handle, 4096);

    if($buffer==FALSE) {
		updateConfig('lastLogOffset', ftell($handle));
		continue;
    }
    $record=preg_split("/\s+/",$buffer);
    if($record[0] <= $lastTimestamp) {
		updateConfig('lastLogOffset', ftell($handle));
		continue;
    }
    
    if($record[3] == 'TCP_DENIED/407'){
		updateConfig('lastLogOffset',ftell($handle));
		continue;
	}

	if($record[3] == 'TCP_DENIED/403'){
		updateConfig('lastLogOffset',ftell($handle));
		continue;
	}

	$lastImportedRecordsNumber++;

	$dbRecord['date']=date('Y-m-d',$record[0]+$timezone_diff);
	$dbRecord['time']=date('H:i:s',$record[0]+$timezone_diff);
	$dbRecord['summaryTime']=date('H',$record[0]+$timezone_diff);
	$dbRecord['ip']=$dbIP=$record[2];
	$dbRecord['resultCode']=$record[3];
	$dbRecord['bytes']=$record[4];
	$dbRecord['url']=addslashes($record[6]);
    $dbRecord['authuser']= substr($record[7],0,50);
    
    $resultCodeArray=explode('/',$dbRecord['resultCode']);
	if(in_array($resultCodeArray[0],$inCacheCodes)) {
		$dbRecord['field']='inCache';
	} else {
		$dbRecord['field']='outCache';
	}

	if($dbRecord['bytes']==0) {
		updateConfig('lastLogOffset',ftell($handle));
		continue;
	}

	$dbUrlArray = parse_url($dbRecord['url']);

	# valida url caso tenha algum caracter invalido como �'D��, /wv7Vټ ,  އ�
	if (filter_var($url, FILTER_VALIDATE_URL)) {
		$dbRecord['url'] = $dbRecord['url'];
	} else {
		if(empty($dbUrlArray['scheme'])) {
			$dbUrl='http';
		} else {
			$dbUrl=$dbUrlArray['scheme'];
		}
		
		$dbUrl.='://'.$dbUrlArray['host'];
		if(!(empty($dbUrlArray['port']) || $dbUrlArray['port']=='80')) {
			$dbUrl.=':'.$dbUrlArray['port'];
		}

		$dbRecord['url'] = $dbUrl;
	}

	if(isset($dbUrlArray['scheme']) && $dbUrlArray['scheme']=='error') {
		updateConfig('lastLogOffset',ftell($handle));
		continue;
	}

	if($dbUrlArray['host'] == 'cache_object') {
		updateConfig('lastLogOffset',ftell($handle));
		continue;
	}
	
	
    $db = new DBConn();
    $conn = $db->DBConn();

    $query1='INSERT INTO traffic (date,time,ip,resultCode,bytes,url,authuser) VALUES (';
	$query1.="'".$dbRecord['date']."'";
	$query1.=',';
	$query1.="'".$dbRecord['time']."'";
	$query1.=',';
	$query1.="INET_ATON('".$dbRecord['ip']."')";
	$query1.=',';
	$query1.="'".$dbRecord['resultCode']."'";
	$query1.=',';
	$query1.="'".$dbRecord['bytes']."'";
	$query1.=',';
	$query1.="'".$dbRecord['url']."'";
	$query1.=',';
	$query1.="'".$dbRecord['authuser']."'";
	$query1.=')';
    $conn->query($query1);
    
	$dbRecord['id'] =  $conn->lastInsertId();

	sleep(0.5);

    $query2="SELECT id FROM hostnames WHERE ip = INET_ATON('".$dbRecord['ip']."')";
    $stmt  = $conn->query($query2);
    $recordSet = $stmt->fetchAll()[0];	

    sleep(0.5);
    if($recordSet['id'] == '') {
        $query3='INSERT INTO ';
        $query3.='hostnames';
        $query3.='(';
        $query3.='ip';
        $query3.=',';
        $query3.='hostname';
        $query3.=') VALUES (';
        $query3.="INET_ATON('".$dbRecord['ip']."')";
        $query3.=',';
        $query3.="'".$dbRecord['ip']."'";
        $query3.=')';
        $stmt = $conn->query($query3);		
        $hostnamesID = $conn->lastInsertId();
    }else{
        $hostnamesID = $recordSet['id'];
    }

    if(empty($dbUrlArray['scheme'])) {
        $dbUrl='http';
    } else {
        $dbUrl=$dbUrlArray['scheme'];
    }
    $dbUrl.='://'.$dbUrlArray['host'];
    if(!(empty($dbUrlArray['port']) || $dbUrlArray['port']=='80')) {
        $dbUrl.=':'.$dbUrlArray['port'];
    }
    $dbUrl.='/';
    sleep(0.5);
    $query4="SELECT id FROM sites WHERE date='".$dbRecord['date']."' AND site='".$dbUrl."'";
	$stmt  = $conn->query($query4);
	$recordSetSite = $stmt->fetchAll()[0];
    
    if($recordSetSite['id'] == '') {
        $query5="INSERT INTO sites(site,date) VALUES ('$dbUrl','".$dbRecord['date']."')";
		$stmt  = $conn->query($query5);
        $sitesID = $conn->lastInsertId();
    } else {
        $sitesID = $recordSetSite['id'];
    }

    $query6="SELECT id FROM users WHERE date='".$dbRecord['date']."' AND authuser='".$dbRecord['authuser']."'";
    $stmt  = $conn->query($query6);
    $recordSet = $stmt->fetchAll()[0];

    if($recordSet['id']=='') {
        $query7="INSERT INTO users(authuser,date) VALUES ('".$dbRecord['authuser']."','".$dbRecord['date']."')";
        $stmt  = $conn->query($query7);
        $usersID = $conn->lastInsertId();
    } else {
        $usersID = $recordSet['id'];
    }
    sleep(0.5);
    $query8='UPDATE ';
		$query8.='trafficSummaries SET ';
		$query8.=$dbRecord['field'].'='.$dbRecord['field'].'+'.$dbRecord['bytes'];
		$query8.=' WHERE ';
		$query8.="date='".$dbRecord['date']."'";
		$query8.=" AND ";
		$query8.="ip=INET_ATON('".$dbRecord['ip']."')";
		$query8.=" AND ";
		$query8.="sitesID='$sitesID'";
		$query8.=" AND ";
		$query8.="usersID='$usersID'";
		$query8.=" AND ";
		$query8.="summaryTime='".$dbRecord['summaryTime']."'";
		$stmt  = $conn->query($query8);
        sleep(0.5);
        $affectedRows = $stmt->rowCount();
        sleep(0.5);
        if($affectedRows==0) {
            $query9 ='INSERT INTO trafficSummaries(date, ip, '.$dbRecord['field'].', sitesID, usersID, summaryTime) VALUES (';
			$query9.="'".$dbRecord['date']."'";
			$query9.=',';
			$query9.="INET_ATON('".$dbRecord['ip']."')";
			$query9.=',';
			$query9.="'".$dbRecord['bytes']."'";
			$query9.=',';
			$query9.="'$sitesID'";
			$query9.=',';
			$query9.="'$usersID'";
			$query9.=',';
			$query9.="'".$dbRecord['summaryTime']."'";
			$query9.=')';
			$stmt  = $conn->query($query9);
			$insertID = $conn->lastInsertId();
			//print_r($affectedRows);
		}
            sleep(0.5);	
            $query10='UPDATE ';
            $query10.='traffic ';
            $query10.='SET ';
            $query10.="sitesID='".$sitesID."'";
            $query10.=',';
            $query10.="usersID='".$usersID."'";
            $query10.=' WHERE ';
            $query10.="id='".$dbRecord['id']."'";
            $stmt  = $conn->query($query10);
        
        sleep(0.5);	
        updateConfig('lastTimeStamp',$record[0]);
        sleep(0.5);
		updateConfig('lastLogOffset', ftell($handle));
		

endforeach;    


my_exit(0);


?>