<?php

class DBConn {

    function DBConn(){
        $basePath=realpath(dirname(__FILE__).'/../');
        
        if(file_exists($basePath.'/etc/config.ini')) {
            $iniConfig=parse_ini_file($basePath.'/etc/config.ini');
        } else {
            $iniConfig=parse_ini_file($basePath.'/etc/config.ini.example');
        };

        $host = $iniConfig['dbHost'];
        $dbname = $iniConfig['dbName'];
        $user = $iniConfig['dbUser'];
        $pass = $iniConfig['dbPass'];

        try {
            $DBH = new PDO("mysql:host=$host;dbname=$dbname", $user, $pass);
            $DBH->setAttribute( PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
            $DBH->setAttribute(PDO::MYSQL_ATTR_USE_BUFFERED_QUERY, true);
            $DBH->setAttribute(PDO::ATTR_PERSISTENT, false);
            $DBH->exec("SET NAMES 'utf8'");
            return $DBH;
        }
        catch(PDOException $e) {
            echo 'ERROR: ' . $e->getMessage();
        }
    } // function ends
} // class ends

?>