<?php

$basePath = realpath(dirname(__FILE__).'/../../');
$ini_array = parse_ini_file($basePath.'/etc/config.ini', true);

#pega da raiz do servidor cudido 
$basePath = realpath(dirname(__FILE__).'/../../../../../');
$idioma = parse_ini_file($basePath.'/var/netdeep/main/settings', true);    

$_SESSION['LOCALE'] = $idioma['LOCALE'];



// CONFIGRAÇÕES DO BANCO ####################
define('HOST', $ini_array['dbHost']);
define('USER', $ini_array['dbUser']);
define('PASS', $ini_array['dbPass']);
define('DBSA', $ini_array['dbName'] );

$timezone = explode((string)"/", (string)$idioma['TIMEZONE']);

date_default_timezone_set($timezone[5].'/'.$timezone[6]);
date_default_timezone_set('UTC'); 

// CONFIGRAÇÕES DO SITE ####################
define('SITENAME','NetDeep');
define('SITEDESC','Firewall ');

// CONFIGRAÇÕES DO EMAIL ####################
define('MAILUSER','suporte@netdeep.com.br');
define('MAILPASS','');
define('MAILPORT','587');
define('MAILHOST','');

// AUTO LOAD DE CLASSES ####################
function __autoload($Class) {
    $cDir = ['Conn', 'Helpers', 'Models'];
    $iDir = null;
    foreach ($cDir as $dirName):
        if (!$iDir && file_exists(__DIR__ . DIRECTORY_SEPARATOR . "{$dirName}". DIRECTORY_SEPARATOR ."{$Class}.class.php") && !is_dir(__DIR__ . DIRECTORY_SEPARATOR ."{$dirName}". DIRECTORY_SEPARATOR ."{$Class}.class.php")):
            include_once (__DIR__ . DIRECTORY_SEPARATOR . "{$dirName}". DIRECTORY_SEPARATOR ."{$Class}.class.php");
            $iDir = true;
        endif;
    endforeach;
    if (!$iDir):
        trigger_error("Não foi possível incluir {$Class}.class.php", E_USER_ERROR);
        die;
    endif;
}


include "gettext/Gettext.php";
include "gettext/Streams.php";

$local = realpath(dirname(__FILE__).'/../../../../../');
$locale_lang = $_SESSION['LOCALE'];
$locale_file = new FileReader($local."/usr/share/locale/".$locale_lang."/LC_MESSAGES/ipcop.mo");
$locale_fetch = new gettext_reader($locale_file);



function __($text) {
    global $locale_fetch;
    return $locale_fetch->translate($text);
}


// TRATAMENTO DE ERROS #####################
//CSS constantes :: Mensagens de Erro
define('WS_ACCEPT', 'alert alert-success alert-dismissible fade in');
define('WS_INFOR', 'alert alert-info alert-dismissible fade in');
define('WS_ALERT', 'alert alert-warning alert-dismissible fade in');
define('WS_ERROR', 'alert alert-danger alert-dismissible fade in');

//WSErro :: Exibe erros lançados :: Front
function WSErro($ErrMsg, $ErrNo, $ErrDie = null) {
    $CssClass = ($ErrNo == E_USER_NOTICE ? WS_INFOR : ($ErrNo == E_USER_WARNING ? WS_ALERT : ($ErrNo == E_USER_ERROR ? WS_ERROR : $ErrNo)));
    echo "<div class=\"{$CssClass}\">
	<button type=\"button\" class=\"close\" data-dismiss=\"alert\" aria-label=\"Close\"><span aria-hidden=\"true\">×</span>
	 </button>{$ErrMsg}</div>";

    if ($ErrDie):
        die;
    endif;
}

//PHPErro :: personaliza o gatilho do PHP
function PHPErro($ErrNo, $ErrMsg, $ErrFile, $ErrLine) {
    $CssClass = ($ErrNo == E_USER_NOTICE ? WS_INFOR : ($ErrNo == E_USER_WARNING ? WS_ALERT : ($ErrNo == E_USER_ERROR ? WS_ERROR : $ErrNo)));
    echo "<p class=\"trigger {$CssClass}\">";
    echo "<b>Erro na Linha: #{$ErrLine} ::</b> {$ErrMsg}<br>";
    echo "<small>{$ErrFile}</small>";
    echo "<span class=\"ajax_close\"></span></p>";

    if ($ErrNo == E_USER_ERROR):
        die;
    endif;
}

set_error_handler('PHPErro');
