<?php

/**
 * Check.class [ HELPER ]
 * Classe responável por manipular e validade dados do sistema!
 * 
 * @copyright (c) 2015, Guardiaot 
 */
class Check {

    private static $Data;
    private static $Format;

    /**
     * <b>Verifica E-mail:</b> Executa validação de formato de e-mail. Se for um email válido retorna true, ou retorna false.
     * @param STRING $Email = Uma conta de e-mail
     * @return BOOL = True para um email válido, ou false
     */
    public static function Email($Email) {
        self::$Data = (string) $Email;
        self::$Format = '/[a-z0-9_\.\-]+@[a-z0-9_\.\-]*[a-z0-9_\.\-]+\.[a-z]{2,4}$/';

        if (preg_match(self::$Format, self::$Data)):
            return true;
        else:
            return false;
        endif;
    }

    /**
     * <b>Tranforma URL:</b> Tranforma uma string no formato de URL amigável e retorna o a string convertida!
     * @param STRING $Name = Uma string qualquer
     * @return STRING = $Data = Uma URL amigável válida
     */
    public static function Name($Name) {
        self::$Format = array();
        self::$Format['a'] = 'ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎÏÐÑÒÓÔÕÖØÙÚÛÜüÝÞßàáâãäåæçèéêëìíîïðñòóôõöøùúûýýþÿRr"!@#$%&*()_-+={[}]/?;:.,\\\'<>°ºª';
        self::$Format['b'] = 'aaaaaaaceeeeiiiidnoooooouuuuuybsaaaaaaaceeeeiiiidnoooooouuuyybyRr';
        self::$Data = strtr(utf8_decode($Name), utf8_decode(self::$Format['a']), self::$Format['b']);
        self::$Data = strip_tags(trim(self::$Data));
		self::$Data = str_replace('/', '-', self::$Data);
        self::$Data = str_replace(' ', '-', self::$Data);
        self::$Data = str_replace(array('-----', '----', '---', '--'), '-', self::$Data);
        return strtolower(utf8_encode(self::$Data));
    }

    /**
     * <b>Tranforma Data:</b> Transforma uma data no formato DD/MM/YY em uma data no formato TIMESTAMP!
     * @param STRING $Name = Data em (d/m/Y) ou (d/m/Y H:i:s)
     * @return STRING = $Data = Data no formato timestamp!
     */
    public static function Data($Data) {
        self::$Format = explode(' ', $Data);
        self::$Data = explode('/', self::$Format[0]);
        if (empty(self::$Format[1])):
            self::$Format[1] = date('H:i:s');
        endif;
        self::$Data = self::$Data[2] . '-' . self::$Data[1] . '-' . self::$Data[0] . ' ' . self::$Format[1];
        return self::$Data;
    }
	
	public static function DataSH($Data) {
        self::$Format = explode(' ', $Data);
        self::$Data = explode('/', self::$Format[0]);
        
        self::$Data = self::$Data[2] . '-' . self::$Data[1] . '-' . self::$Data[0];
        return self::$Data;
    }

    /**
     * <b>Limita os Palavras:</b> Limita a quantidade de palavras a serem exibidas em uma string!
     * @param STRING $String = Uma string qualquer
     * @return INT = $Limite = String limitada pelo $Limite
     */
    public static function Words($String, $Limite, $Pointer = null) {
        self::$Data = strip_tags(trim($String));
        self::$Format = (int) $Limite;
        $ArrWords = explode(' ', self::$Data);
        $NumWords = count($ArrWords);
        $NewWords = implode(' ', array_slice($ArrWords, 0, self::$Format));
        $Pointer = (empty($Pointer) ? '...' : ' ' . $Pointer );
        $Result = ( self::$Format < $NumWords ? $NewWords . $Pointer : self::$Data );
        return $Result;
    }

    /**
     * <b>Obter categoria:</b> Informe o name (url) de uma categoria para obter o ID da mesma.
     * @param STRING $category_name = URL da categoria
     * @return INT $category_id = id da categoria informada
     */
    public static function CatByName($CategoryName) {
        $read = new Read;
        $read->ExeRead('menu', "WHERE link = :name", "name={$CategoryName}");
        if ($read->getRowCount()):
            return $read->getResult()[0]['id'];
        else:
            echo "A categoria {$CategoryName} não foi encontrada!";
            die;
        endif;
    }


	public static function converte_data($data) {
	 
		/*
		 * Caso a data tenha horas, 
		 * separa a data da hora.
		 */
		$hora = '';
	 
		if (strstr($data, ' ')) {
			$data = explode(' ', $data);
	 
			$hora = $data[1];
			$data = $data[0];
		}
	 
		/*
		 * Reorganiza a data para ficar 
		 * no padrão americano.
		 * yyyy-mm-dd hh:mm:ss
		 */
		$data = explode('/', $data);
		$data = array_reverse($data);
		$data = implode('-',$data);
	 
		/*
		 * Se a data possui hora,
		 * a função retorna a data e hora.
		 * Caso não exista hora,
		 * retorna apenas a data
		 */
		if ($hora != '') {
			return $data . ' ' . $hora;
		}
		else {
			return $data;
		}
	 
	}
    /**
     * <b>Usuários Online:</b> Ao executar este HELPER, ele automaticamente deleta os usuários expirados. Logo depois
     * executa um READ para obter quantos usuários estão realmente online no momento!
     * @return INT = Qtd de usuários online
     */
    public static function UserOnline() {
        $now = date('Y-m-d H:i:s');
        $deleteUserOnline = new Delete;
        $deleteUserOnline->ExeDelete('ws_siteviews_online', "WHERE online_endview < :now", "now={$now}");
        $readUserOnline = new Read;
        $readUserOnline->ExeRead('ws_siteviews_online');
        return $readUserOnline->getRowCount();
    }

    /**
     * <b>Imagem Upload:</b> Ao executar este HELPER, ele automaticamente verifica a existencia da imagem na pasta
     * uploads. Se existir retorna a imagem redimensionada!
     * @return HTML = imagem redimencionada!
     */
    public static function Image($ImageUrl, $ImageDesc, $ImageW = null, $ImageH = null) {
        self::$Data = $ImageUrl;
        if (file_exists(self::$Data) && !is_dir(self::$Data)):
            $patch = HOME;
            $imagem = self::$Data;
            return "<img src=\"{$patch}/tim.php?src={$patch}/{$imagem}&w={$ImageW}&h={$ImageH}\" alt=\"{$ImageDesc}\" title=\"{$ImageDesc}\"/>";
        else:
            return false;
        endif;
    }
	
	
	/**
	* transforma data hora padrão brasileiro para o padrão do banco de dados
	*
	* @param string $data
	*        	ex(dd/mm/yyy)
	* @return string ex(yyyy-mm-dd HH:mm:ss)
	*/
	public static function dataHoraBr($data) {
		list ( $data, $hora ) = explode ( " ", $data );
		
		if ($data) {
			list ( $ano, $mes, $dia ) = explode ( "-", array_shift ( explode ( " ", $data ) ) );
			if (checkdate ( $mes, $dia, $ano )) {
				return $dia . "/" . $mes . "/" . $ano . " " . $hora;
			}
		}
		return $data;
	}

	public static function dataDB($data) {
		$data = explode ( "-", $data );
		return $data[2] . "/" . $data[1] . "/" . $data[0] ;
	}
	/**
	* transforma data hora padrão brasileiro para o padrão do banco de dados
	*
	* @param string $data
	*        	ex(dd/mm/yyy)
	* @return string ex(yyyy-mm-dd HH:mm:ss)
	*/
	public static function dataHoraDB($dataHora) {
		        $d  = explode("/", $dataHora);
				return $d[2] . "-" . $d[1] . "-" . $d[0];
	}

	public static function adicionaData($data, $ndia){
		$data = date('d/m/Y', strtotime('+'.$ndia.' days', strtotime($data)));
		return $data;
	}
	
    public static function subtraiData($data, $ndia){
		$data = date('d/m/Y', strtotime('-'.$ndia.' days', strtotime($data)));
		return $data;
	}
	
	public static function adicionaDataBD($data, $ndia){
		$data = date('Y-m-d', strtotime('+'.$ndia.' days', strtotime($data)));
		return $data;
	}
	
    public static function subtraiDataBD($data, $ndia){
		$data = date('Y-m-d', strtotime('-'.$ndia.' days', strtotime($data)));
		return $data;
	}
	
	public static function By2M($size){
		$filesizename = array(" Bytes", " KB", " MB", " GB", " TB", " PB", " EB", " ZB", " YB");
		return $size ? round($size/pow(1024, ($i = floor(log($size, 1024)))), 2) . $filesizename[$i] : '0 Bytes';
	}	
	
	public  static function RoundSigDigs($number, $sigdigs) { 
    $multiplier = 1; 
    while ($number < 0.1) { 
        $number *= 10; 
        $multiplier /= 10; 
    } 
    while ($number >= 1) { 
        $number /= 10; 
        $multiplier *= 10; 
    } 
    return round($number, $sigdigs) * $multiplier; 
	} 
	
	public static function bytekb($byte){
		return number_format($byte / 1024, 2);
	}
	
	public static function Linguagem($string){
		if($string == 'en_GB'){
			$arr[] = array(
				"#Titulo1#" => "Web Browsing Reports ",
				"#Titulo2#" => "Netdeep Secure - Web Browsing Report",
				"#Informacao1#" => "Login report for the period from",
				"#Tituloprint#" => "Web Navigation report",
				"#avisoprint#" => "To locate a line, use the CTRL+F",
				"#campoDatainicio#" => "Start date",
				"#campoDatafim#" => "End Date",
				"#campoHora#" => "Time",
				"#campoUsuario#" => "User",
				"#campoBusca#" => "Search by",
				"#campoSelecao#" => "Select",
				"#campoEstacao#" => "Host",
				"#a#" => "the",
				"#nohorario#" => "in Time in",
				"#noregistro#" => "No record found!",
				"#imprimir#" => "Print",
				"#filtrar#" => "Filter",
				"#relatorio#" => "Report",
				"#relatoriodetalhado#" => "Full",
				"#gridUser#" => "USER",
				"#gridDate#" => "DATE",
				"#gridHora#" => "TIME",
				"#grideexport#" => "Export",
				"#grideorde#" => "Sort by",
				"#gridregistro#" => "Records",
				"#gridPagina#" => "Page",
				"#gridPaginas#" => "Pages",
				"#bandautilizada#" => "USED BAND",
				"#utilizacao#" => "Using the period",
				"#siteacessado#" => "Most accessed sites",
				"#bandausuario#" => "Per user used bandwidth",
				"#bandasite#" => "Site for used bandwidth",
				"#detalhes#" => " + Details",
				"#acesso#" => "Access",
				"#consumoporip#" => "Used bandwidth by IP",
				"#thorasconectado#" => "TOTAL HOURS CONNECTED",
				"#nivel#" => "up to",
				"#subdominio#" => "subdomain(s)",
				"#urlcompleta#" => "Full",
				"#labelurl#" => "Show URL...",
				"#gridTempo#" => "LAST TIME",
				"#timesite#" => 'Last time per site',
				"#timeip#" => 'Last time per IP',
				"#timeusuario#" => 'Last time per User',
				"#menutempo#" => 'Time'
			);
		}else if($string == 'pt_BR'){
			$arr[] = array(
				"#Titulo1#" => "Registros de Navegação ",
				"#Titulo2#" => "Netdeep Secure - Registros de Navegação Web",
				"#Informacao1#" => "Relatório de Acesso no período de",
				"#avisoprint#" => "Para localizar uma linha utilize o CTRL+F ",
				"#noregistro#" => "Registro não encontrado!",
				"#Tituloprint#" => "Registros de Navegação Web",
				"#campoDatainicio#" => "Data início",
				"#campoDatafim#" => "Data fim",
				"#campoHora#" => "Horas",
				"#campoUsuario#" => "Usuário",
				"#campoBusca#" => "Procurar por",
				"#campoSelecao#" => "Selecionar",
				"#campoEstacao#" => "Estação",
				"#a#" => "a",
				"#nohorario#" => "no Horário de",
				"#imprimir#" => "Imprimir",
				"#filtrar#" => "Filtrar",
				"#relatorio#" => "Resumidos",
				"#relatoriodetalhado#" => "Detalhados",
				"#gridUser#" => "USUÁRIO",
				"#gridDate#" => "DATA",
				"#gridHora#" => "HORÁRIO",
				"#grideexport#" => "Exportar",
				"#grideorde#" => "Ordenado por",
				"#gridregistro#" => "Registros",
				"#gridPagina#" => "Página",
				"#gridPaginas#" => "Páginas",
				"#campoEstacaoup#" => "ESTAÇÃO",
				"#bandautilizada#" => "BANDA UTILIZADA",
				"#utilizacao#" => "Utilização no período",
				"#siteacessado#" => "Sites mais acessados",
				"#bandausuario#" => "Consumo de banda por Usuário",
				"#bandasite#" => "Consumo de banda por Sites",
				"#detalhes#" => " + Detalhes",
				"#acesso#" => "Acessos",
				"#consumoporip#" => "Consumo de banda por IP",
				"#thorasconectado#" => "TOTAL HORAS CONECTADO",
				"#nivel#" => "Até",
				"#subdominio#" => "subdominio(s)",
				"#urlcompleta#" => "Completa",
				"#labelurl#" => "Exibir URL...",
				"#gridTempo#" => "TEMPO GASTO",
				"#timesite#" => 'Tempo gasto por Sites',
				"#timeip#" => 'Tempo gasto por IP',
				"#timeusuario#" => 'Tempo gasto por Usuário',
				"#menutempo#" => 'Tempo'
				
			);
			}else if($string == 'es_ES'){
				$arr[] = array(
				"#Titulo1#" => "Registros de navegación",
				"#Titulo2#" => "Netdeep Secure - Registros de navegación Web",
				"#Informacao1#" => "Informe de Acceso en el período de",
				"#avisoprint#" => "Para buscar una línea utilice el CTRL+F ",
				"#noregistro#" => "Registro no encontrado!",
				"#Tituloprint#" => "Registros de navegación Web",
				"#campoDatainicio#" => "Fecha inicio",
				"#campoDatafim#" => "Fecha final",
				"#campoHora#" => "Horas",
				"#campoUsuario#" => "Usuário",
				"#campoBusca#" => "Buscar por",
				"#campoSelecao#" => "Seleccionar",
				"#campoEstacao#" => "Temporada",
				"#a#" => "a",
				"#nohorario#" => "en el Horario de",
				"#imprimir#" => "impresión",
				"#filtrar#" => "filtro",
				"#relatorio#" => "Resumidos",
				"#relatoriodetalhado#" => "Detallado",
				"#gridUser#" => "USUÁRIO",
				"#gridDate#" => "FECHA",
				"#gridHora#" => "HORAS",
				"#grideexport#" => "Exportación",
				"#grideorde#" => "Ordenado por",
				"#gridregistro#" => "Archivos",
				"#gridPagina#" => "Página",
				"#gridPaginas#" => "Páginas",
				"#campoEstacaoup#" => "Temporada",
				"#bandautilizada#" => "BANDA UTILIZADA",
				"#utilizacao#" => "Utilización en el período",
				"#siteacessado#" => "Sitios más visitados",
				"#bandausuario#" => "Consumo de banda por usuario",
				"#bandasite#" => "Consumo de banda por Sitios",
				"#detalhes#" => " + Detalhes",
				"#acesso#" => "Acessos",
				"#consumoporip#" => "Consumo de banda por IP",
				"#thorasconectado#" => "TOTAL HORAS CONECTADAS",
				"#nivel#" => "Para",
				"#subdominio#" => "subdominio(s)",
				"#urlcompleta#" => "Completo",
				"#labelurl#" => "Visualización URL...",
				"#gridTempo#" => "TIEMPO GASTO",
				"#timesite#" => 'Tiempo gastado por Sitios',
				"#timeip#" => 'Tiempo gastado por IP',
				"#timeusuario#" => 'Tiempo gastado por Usuário',
				"#menutempo#" => 'Tiempo'
				);
			}	
	
	 return $arr;
	}
}
