<?php

#
# This file is part of the Netdeep Secure Firewall.
#
# Netdeep Secure is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Netdeep Secure is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Netdeep Secure; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
#
# (c) 2015 - www.netdeep.com.br
#

class Seo {

    private $File;
    private $Link;
    private $Data;
    private $Tags;

    /* DADOS POVOADOS */
    private $seoTags;
    private $seoData;

    function __construct($File, $Link) {
        $this->File = strip_tags(trim($File));
        $this->Link = strip_tags(trim($Link));
    }

    /**
     * <b>Obter MetaTags:</b> Execute este método informando os valores de navegação para que o mesmo obtenha
     * todas as metas como title, description, og, itemgroup, etc.
     * 
     * <b>Deve ser usada com um ECHO dentro da tag HEAD!</b>
     * @return HTML TAGS =  Retorna todas as tags HEAD
     */
    public function getTags() {
        $this->checkData();
        return $this->seoTags;
    }

    /**
     * <b>Obter Dados:</b> Este será automaticamente povoado com valores de uma tabela single para arquivos
     * como categoria, artigo, etc. Basta usar um extract para obter as variáveis da tabela!
     * 
     * @return ARRAY = Dados da tabela
     */
    public function getData() {
        $this->checkData();
        return $this->seoData;
    }

    /*
     * ***************************************
     * **********  PRIVATE METHODS  **********
     * ***************************************
     */

    //Verifica o resultset povoando os atributos
    private function checkData() {
        if (!$this->seoData):
            $this->getSeo();
        endif;
    }

    //Identifica o arquivo e monta o SEO de acordo
    private function getSeo() {
        $ReadSeo = new Read;

        switch ($this->File):
              case 'detalhes':
                 $ReadSeo->ExeRead("anuncio", "WHERE nome_url = :link", "link={$this->Link}");
				 if (!$ReadSeo->getResult()):
                    $this->seoData = null;
                    $this->seoTags = null;
                else:
				    extract($ReadSeo->getResult()[0]);
                    $this->seoData = $ReadSeo->getResult()[0];
 				  
				   //category:: conta views da categoria
                    $ArrUpdate = ['visualizacao_detalhe' => $visualizacao_detalhe + 1];
                    $Update = new Update();
                    $Update->ExeUpdate("anuncio", $ArrUpdate, "WHERE id = :catid", "catid={$id}");	
					
					$dataValida = date('Y-m-d');
					$desativar = ['status' => 0];
					$upDesativa = new Update();
					$upDesativa->ExeUpdate("anuncio", $desativar, " WHERE data_cadastro2 < :validade ", "validade={$dataValida}");				
				endif;
                break;
				
				case 'categoria':
				$ReadSeo->ExeRead("menu", "WHERE link = :link", "link={$this->Link}");
                if (!$ReadSeo->getResult()):
                    $this->seoData = null;
                    $this->seoTags = null;
                else:
                    extract($ReadSeo->getResult()[0]);
                    $this->seoData = $ReadSeo->getResult()[0];
                    $this->Data = [$nome . ' - ' . SITENAME, $nome, HOME . "/categoria/{$link}", 
					INCLUDE_PATH . '/images/site.png'];
                endif;
				break;
				
				case 'subcategoria':
                $ReadSeo->ExeRead("menu", "WHERE link = :link", "link={$this->Link}");
                if (!$ReadSeo->getResult()):
                    $this->seoData = null;
                    $this->seoTags = null;
                else:
                    extract($ReadSeo->getResult()[0]);
                    $this->seoData = $ReadSeo->getResult()[0];
                    $this->Data = [$nome . ' - ' . SITENAME, $nome, HOME . "/subcategoria/{$link}", 
					INCLUDE_PATH . '/images/site.png'];
                endif;
                break;
            //SEO:: PESQUISA
            case 'pesquisa':
                $ReadSeo->ExeRead("anuncio", "WHERE status = 1 AND 
				(nome LIKE '%' :link '%' OR descricao LIKE '%' 
				:link '%')", "link={$this->Link}");
                if (!$ReadSeo->getResult()):
                    $this->seoData = null;
                    $this->seoTags = null;
                else:
                    $this->seoData['count'] = $ReadSeo->getRowCount();
                    $this->Data = ["Pesquisa por: {$this->Link}" . ' - ' . SITENAME,
					 "Sua pesquisa por {$this->Link} retornou {$this->seoData['count']} 
					 resultados!", HOME . "/pesquisa/{$this->Link}", 
					 INCLUDE_PATH . '/images/site.png'];
                endif;
                break;
				
			case 'cidades':
                $ReadSeo->ExeRead("anuncio", "WHERE status = 1 AND (nome LIKE '%' :link '%' OR descricao LIKE '%' 
				:link '%')", "link={$this->Link}");
                if (!$ReadSeo->getResult()):
                    $this->seoData = null;
                    $this->seoTags = null;
                else:
                    $this->seoData['count'] = $ReadSeo->getRowCount();
                    $this->Data = ["Pesquisa por: {$this->Link}" . ' - ' . SITENAME,
					 "Sua pesquisa por {$this->Link} retornou {$this->seoData['count']} 
					 resultados!", HOME . "/pesquisa/{$this->Link}", 
					 INCLUDE_PATH . '/images/site.png'];
                endif;
                break;
			//SEO:: login da lista
			case 'minha-lista':
			if (isset($_SESSION['usuario']) && $_SESSION['usuario'] != ''):
			$Name = ucwords(str_replace("-", " ", $this->Link));
			$this->seoData = ["login" => $this->Link, "login" => $Name];
			$this->Data = ["{$this->Link}" . SITENAME, "Faça o login  {$this->Link}.",	HOME . '/empresas/' . $this->Link, 
			INCLUDE_PATH . '/images/site.png'];
			else:
				header('Location: ' . HOME . DIRECTORY_SEPARATOR . 'fecharlista');
			endif;
			break;
			
			//SEO:: login da lista
			case 'fecharlista':
				$this->Data = ["login ou cadastrar - " . 
				SITENAME, "Página modelo para cadastro de empresas via Front-End do curso Work Series - 
				PHP Orientado a Objetos!", HOME . '/cadastra-empresa/' . $this->Link, 
				INCLUDE_PATH . '/images/site.png'];
			break;
			
			//SEO:: login da lista
			case 'registra':
			 $this->Data = ["Registra-se - " . 
				SITENAME, "Página modelo para cadastro de empresas via Front-End do curso Work Series - 
				PHP Orientado a Objetos!", HOME . '/cadastra-empresa/' . $this->Link, 
				INCLUDE_PATH . '/images/site.png'];
			break;		
			
			case 'cadastro-sucesso':
			 $this->Data = ["Obrigado por registrar - " . 
				SITENAME, "Página modelo para cadastro de empresas via Front-End do curso Work Series - 
				PHP Orientado a Objetos!", HOME . '/cadastra-empresa/' . $this->Link, 
				INCLUDE_PATH . '/images/site.png'];
			break;
			
			
			case 'usuario-sucesso':
			$this->Data = ["E-mail já esta sendo usado - " . 
				SITENAME, "Pagina de aviso email esta em uso..! - 
				PHP Orientado a Objetos!", HOME . '/cadastra-empresa/' . $this->Link, 
				INCLUDE_PATH . '/images/site.png'];
			break;
            //SEO:: LISTA EMPRESAS
            case 'empresas':
                $Name = ucwords(str_replace("-", " ", $this->Link));
                $this->seoData = ["empresa_link" => $this->Link, "empresa_cat" => $Name];
                $this->Data = ["Empresas {$this->Link}" . SITENAME, 
				"Confira o guia completo de sua cidade, e encontra empresas {$this->Link}.", 
				HOME . '/empresas/' . $this->Link, 
				INCLUDE_PATH . '/images/site.png'];
				
                $ReadSeo->ExeRead("clientes", "WHERE  nome_url = '{$this->Link}' ");
                if (!$ReadSeo->getResult()):
                    $this->seoData = null;
                    $this->seoTags = null;
                else:
                    extract($ReadSeo->getResult()[0]);
                    $this->seoData = $ReadSeo->getResult()[0];
                    $this->Data = [$nome . ' - ' . SITENAME, $sobre, HOME . "/empresa/{$nome}", HOME . "/uploads/{$logo}"];
				    
					
					$cidade = new Read;
					$cidade->ExeRead("app_cidades", " WHERE cidade_id = :idc ", "idc={$this->seoData['cidade']}");
					$cid = $cidade->getResult()[0];
					
					$this->seoData['nom_cidade'] = $cid['cidade_nome'];
					
					$estado = new Read;
					$estado->ExeRead("app_estados", " WHERE estado_id = :ide ", "ide={$this->seoData['estado']}");
					$uf = $estado->getResult()[0];
					
					
					$this->seoData['nome_uf'] = $uf['estado_uf'];
							
                    //empresa:: conta views da empresa
                    $ArrUpdate = ['views' => $views + 1];
                    $Update = new Update();
                    $Update->ExeUpdate("clientes", $ArrUpdate, "WHERE status = '1' AND  id = :empresaid", "empresaid={$id}");
                endif;
				
                break;

            //SEO:: EMPRESA SINGLE
            case 'empresa':
                $Admin = (isset($_SESSION['userlogin']['administradores_level']) && 
				$_SESSION['userlogin']['administradores_level'] == 3 ? true : false);
                $Check = ($Admin ? '' : 'status = 1 AND');

                $ReadSeo->ExeRead("clientes", "WHERE {$Check} status = '1' AND id = 1 ");
                if (!$ReadSeo->getResult()):
                    $this->seoData = null;
                    $this->seoTags = null;
                else:
                    extract($ReadSeo->getResult()[0]);
                    $this->seoData = $ReadSeo->getResult()[0];
                    $this->Data = [$nome . ' - ' . SITENAME, $sobre, HOME . "/empresa/{$nome}", HOME . "/uploads/{$logo}"];

                    //empresa:: conta views da empresa
                    $ArrUpdate = ['views' => $views + 1];
                    $Update = new Update();
                    $Update->ExeUpdate("clientes", $ArrUpdate, "WHERE status = '1' AND id = :empresaid", "empresaid={$id}");
                endif;
                break;
				
			
			
			case 'fale-conosco':
				$Name = ucwords(str_replace("-", " ", $this->Link));
                $this->seoData = ["empresa_link" => $this->Link, "empresa_cat" => $Name];
                $this->Data = ["Empresas {$this->Link}" . SITENAME, 
				"tudo que voce precisa ficar sabendo esta aqui {$this->Link}.", 
				HOME . '/empresas/' . $this->Link, 
				INCLUDE_PATH . '/images/site.png'];
			break;
			
            //SEO:: CADASTRA EMPRESA
            case 'cadastra-empresa':
                $this->Data = ["Cadastre sua Empresa - " . 
				SITENAME, "Página modelo para cadastro de empresas via Front-End do curso Work Series - 
				PHP Orientado a Objetos!", HOME . '/cadastra-empresa/' . $this->Link, 
				INCLUDE_PATH . '/images/site.png'];
            break;
			
			case 'cron':
			break;
            //SEO:: INDEX
            case 'index':
                $this->Data = [SITENAME . ' - sites!', SITEDESC, HOME, INCLUDE_PATH . '/images/site.png'];
            break;
			
			
			
            //SEO:: 404
            default :
                $this->Data = [SITENAME . " - 404 Oppsss, Nada encontrado! ", SITEDESC,
				HOME . '/404', INCLUDE_PATH . '/images/site.png'];

        endswitch;

        if ($this->Data):
            $this->setTags();
        endif;
    }
	
    //Monta e limpa as tags para alimentar as tags
    private function setTags() {
        $this->Tags['Title'] = $this->Data[0];
        $this->Tags['Content'] = Check::Words(html_entity_decode($this->Data[1]), 25);
        $this->Tags['Link'] = $this->Data[2];
        $this->Tags['Image'] = $this->Data[3];

        $this->Tags = array_map('strip_tags', $this->Tags);
        $this->Tags = array_map('trim', $this->Tags);

        $this->Data = null;

        //NORMAL PAGE
        $this->seoTags = '<title>' . $this->Tags['Title'] . '</title>' . "\n";
        $this->seoTags .= '<meta name="description" content="' . $this->Tags['Content'] . '"/>' . "\n";
        $this->seoTags .= '<meta name="robots" content="index, follow" />' . "\n";
        $this->seoTags .= '<link rel="canonical" href="' . $this->Tags['Link'] . '">' . "\n";
        $this->seoTags .= "\n";

        //FACEBOOK
        $this->seoTags .= '<meta property="og:site_name" content="' . SITENAME . '" />' . "\n";
        $this->seoTags .= '<meta property="og:locale" content="pt_BR" />' . "\n";
        $this->seoTags .= '<meta property="og:title" content="' . $this->Tags['Title'] . '" />' . "\n";
        $this->seoTags .= '<meta property="og:description" content="' . $this->Tags['Content'] . '" />' . "\n";
        $this->seoTags .= '<meta property="og:image" content="' . $this->Tags['Image'] . '" />' . "\n";
        $this->seoTags .= '<meta property="og:url" content="' . $this->Tags['Link'] . '" />' . "\n";
        $this->seoTags .= '<meta property="og:type" content="article" />' . "\n";
        $this->seoTags .= "\n";

        //ITEM GROUP (TWITTER)
        $this->seoTags .= '<meta itemprop="name" content="' . $this->Tags['Title'] . '">' . "\n";
        $this->seoTags .= '<meta itemprop="description" content="' . $this->Tags['Content'] . '">' . "\n";
        $this->seoTags .= '<meta itemprop="url" content="' . $this->Tags['Link'] . '">' . "\n";

        $this->Tags = null;
    }

}
