<?php
include "config.php";
include "banco.php";

class helper extends banco {

	/**
	* transforma data hora padrão brasileiro para o padrão do banco de dados
	*
	* @param string $data
	*        	ex(dd/mm/yyy)
	* @return string ex(yyyy-mm-dd HH:mm:ss)
	*/
	public function dataHoraBr($data) {
		list ( $data, $hora ) = explode ( " ", $data );
		
		if ($data) {
			list ( $ano, $mes, $dia ) = explode ( "-", array_shift ( explode ( " ", $data ) ) );
			if (checkdate ( $mes, $dia, $ano )) {
				return $dia . "/" . $mes . "/" . $ano . " " . $hora;
			}
		}
		return $data;
	}


	/**
	* transforma data hora padrão brasileiro para o padrão do banco de dados
	*
	* @param string $data
	*        	ex(dd/mm/yyy)
	* @return string ex(yyyy-mm-dd HH:mm:ss)
	*/
	public function dataHoraDB($dataHora) {
		list ( $data, $hora ) = explode ( " ", $dataHora );
		if ($data) {
			list ( $dia, $mes, $ano ) = explode ( "/", $data );
			if (checkdate ( $mes, $dia, $ano )) {
				return $ano . "-" . $mes . "-" . $dia . " " . $hora;
			}
		}
		return $dataHora;
	}

	public function adicionaData($data, $ndia){
		$data = date('d/m/Y', strtotime('+'.$ndia.' days', strtotime($data)));
		return $data;
	}
	
    public function subtraiData($data, $ndia){
		$data = date('d/m/Y', strtotime('-'.$ndia.' days', strtotime($data)));
		return $data;
	}
	
	public function adicionaDataBD($data, $ndia){
		$data = date('Y-m-d', strtotime('+'.$ndia.' days', strtotime($data)));
		return $data;
	}
	
    public function subtraiDataBD($data, $ndia){
		$data = date('Y-m-d', strtotime('-'.$ndia.' days', strtotime($data)));
		return $data;
	}
	
	public function By2M($size){
		$filesizename = array(" Bytes", " KB", " MB", " GB", " TB", " PB", " EB", " ZB", " YB");
		return $size ? round($size/pow(1024, ($i = floor(log($size, 1024)))), 2) . $filesizename[$i] : '0 Bytes';
	}	
	
	public function RoundSigDigs($number, $sigdigs) { 
    $multiplier = 1; 
    while ($number < 0.1) { 
        $number *= 10; 
        $multiplier /= 10; 
    } 
    while ($number >= 1) { 
        $number /= 10; 
        $multiplier *= 10; 
    } 
    return round($number, $sigdigs) * $multiplier; 
	} 
	
	public function bytekb($byte){
		return number_format($byte / 1024, 2);
	}
	
}

?>